import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.applet.*;



public
class UrlStupidity 
    extends Applet 
{
  
// Data  
String              m_strURL;
TextField           m_tfURL;
Label               m_lblHint;
Button              m_btnTest;
Button              m_btnNavigate;
ActionListener      m_lsnrTest,m_lsnrNavigate;

    // Buttons' handlers
    class BtnTestClick 
        implements ActionListener
    {
        public void actionPerformed(ActionEvent e) {
            m_strURL = m_tfURL.getText();
            // Try to load the URL
            try {
                URL urlTest = new URL(m_strURL);
                m_lblHint.setText("No exception. You may navigate to this URL");
            } catch (MalformedURLException exc) {
                m_lblHint.setText("Exception: " + exc.toString() + " TRY ANOTHER URL.");
            }   
            doLayout();
        }
    }
    
    class BtnNavigateClick 
        implements ActionListener
    {
        public void actionPerformed(ActionEvent e) {
            URL urlTest;
            try {
                urlTest = new URL(m_strURL);
                AppletContext   applContext;
                applContext = getAppletContext();
                applContext.showDocument(urlTest);
            } catch (MalformedURLException exc) {
                // Nothing special here
                m_lblHint.setText("Can not navigate. Java exception: " + exc.toString());
            }            
            doLayout();
        }
    }
  
public void init() {
    m_strURL = getParameter("TheURL");
    m_tfURL = new TextField(m_strURL);
    m_lblHint = new Label("Click outside the text field to try the URL");
    m_btnTest = new Button("Test if java can deal with this URL");
    m_btnNavigate = new Button("Try to navigate to the URL");
    add(m_tfURL);
    add(m_btnTest);
    add(m_btnNavigate);
    add(m_lblHint);
    m_lsnrTest = new BtnTestClick();
    m_lsnrNavigate = new BtnNavigateClick();
    m_btnTest.addActionListener(m_lsnrTest);
    m_btnNavigate.addActionListener(m_lsnrNavigate);
}
public void destroy() {
    m_btnTest.removeActionListener(m_lsnrTest);
    m_btnNavigate.removeActionListener(m_lsnrNavigate);
}
public void paint(Graphics g) {
    
}
public String getAppletInfo() {
    return "Stupidity in Java URLs";
}


}
